program S_radial_2d
use sep

implicit none

integer                     :: nx, nt, ix,iz,it
real                        :: dx, dt, dz, ox, ot, oz, v, x, z, r, t, it_exact, frac
real, dimension(:,:),allocatable        :: data

call sep_init()

call from_param('nx',nx,800);   call from_param('dx',dx,0.01);   call from_param('ox',ox,.0) 
call from_param('nt',nt,350);   call from_param('dt',dt,0.004);   call from_param('ot',ot,0.)
call from_param('vel',v,2.)
call to_history("n1",nx);   call to_history("d1",dx);   call to_history("o1",ox)
call to_history("n2",nt);   call to_history("d2",dt);   call to_history("o2",ot)

allocate( data(nx,nt) )
data=0.

write(0,*)"nx,nt",nx,nt

  do ix=1,nx
    x=ox+(ix-1)*dx
    t=ot+abs(x)/v
    it_exact=(t-ot)/dt+1.
    it = it_exact
    frac = it_exact - it 
    if (it > (nt-1)) exit
      data(ix,it)   = (1-frac) * 1./(sqrt(1.*abs(ix-nx-1))*abs(dx))
      data(ix,it+1) =    frac  * 1./(sqrt(1.*abs(ix-nx-1))*abs(dx))
  end do

call sep_write(data)
deallocate(data)

end program S_radial_2d
