module wei_dump
  !! array output for debugging

  use sep

  !---------------
  implicit none

  interface dump
     module procedure dumpI1
     module procedure dumpI2
     module procedure dumpI3
     module procedure dumpI4
     module procedure dumpI5

     module procedure dumpR1
     module procedure dumpR2
     module procedure dumpR3
     module procedure dumpR4
     module procedure dumpR5

     module procedure dumpC1
     module procedure dumpC2
     module procedure dumpC3
     module procedure dumpC4
     module procedure dumpC5
  end interface

  character(len=128), public :: dumpname

contains
  !----------------------------------------------------------------
  subroutine dumpI1(array)
    integer, dimension(:), pointer            :: array
    integer :: esize
    integer :: n1

    call auxscr(trim(dumpname))

    esize = 1
    call auxputch("esize",'i',esize,trim(dumpname))
    n1 = size(array,1)
    call auxputch("n1",'i',n1,trim(dumpname))

    call srite(trim(dumpname),array,n1*esize)
  end subroutine dumpI1
  !----------------------------------------------------------------
  subroutine dumpI2(array)
    integer, dimension(:,:), pointer          :: array
    integer :: esize
    integer :: n1,n2

    call auxscr(trim(dumpname))

    esize = 1
    call auxputch("esize",'i',esize,trim(dumpname))
    n1 = size(array,1)
    call auxputch("n1",'i',n1,trim(dumpname))
    n2 = size(array,2)
    call auxputch("n2",'i',n2,trim(dumpname))

    call srite(trim(dumpname),array,n1*n2*esize)
  end subroutine dumpI2
  !----------------------------------------------------------------
  subroutine dumpI3(array)
    integer, dimension(:,:,:), pointer        :: array
    integer :: esize
    integer :: n1,n2,n3

    call auxscr(trim(dumpname))

    esize = 1
    call auxputch("esize",'i',esize,trim(dumpname))
    n1 = size(array,1)
    call auxputch("n1",'i',n1,trim(dumpname))
    n2 = size(array,2)
    call auxputch("n2",'i',n2,trim(dumpname))
    n3 = size(array,3)
    call auxputch("n3",'i',n3,trim(dumpname))

    call srite(trim(dumpname),array,n1*n2*n3*esize)
  end subroutine dumpI3
  !----------------------------------------------------------------
  subroutine dumpI4(array)
    integer, dimension(:,:,:,:), pointer      :: array
    integer :: esize
    integer :: n1,n2,n3,n4

    call auxscr(trim(dumpname))

    esize = 1
    call auxputch("esize",'i',esize,trim(dumpname))
    n1 = size(array,1)
    call auxputch("n1",'i',n1,trim(dumpname))
    n2 = size(array,2)
    call auxputch("n2",'i',n2,trim(dumpname))
    n3 = size(array,3)
    call auxputch("n3",'i',n3,trim(dumpname))
    n4 = size(array,4)
    call auxputch("n4",'i',n4,trim(dumpname))

    call srite(trim(dumpname),n1*n2*n3*n4*esize)
  end subroutine dumpI4
  !----------------------------------------------------------------
  subroutine dumpI5(array)
    integer, dimension(:,:,:,:,:), pointer    :: array
    integer :: esize
    integer :: n1,n2,n3,n4,n5

    call auxscr(trim(dumpname))

    esize = 1
    call auxputch("esize",'i',esize,trim(dumpname))
    n1 = size(array,1)
    call auxputch("n1",'i',n1,trim(dumpname))
    n2 = size(array,2)
    call auxputch("n2",'i',n2,trim(dumpname))
    n3 = size(array,3)
    call auxputch("n3",'i',n3,trim(dumpname))
    n4 = size(array,4)
    call auxputch("n4",'i',n4,trim(dumpname))
    n5 = size(array,5)
    call auxputch("n5",'i',n5,trim(dumpname))

    call srite(trim(dumpname),array,n1*n2*n3*n4*n5*esize)
  end subroutine dumpI5
  !----------------------------------------------------------------

  !----------------------------------------------------------------
  subroutine dumpR1(array)
    real, dimension(:), pointer            :: array
    integer :: esize
    integer :: n1

    call auxscr(trim(dumpname))

    esize = 4
    call auxputch("esize",'i',esize,trim(dumpname))
    n1 = size(array,1)
    call auxputch("n1",'i',n1,trim(dumpname))

    call sep_write(array,trim(dumpname))
  end subroutine dumpR1
  !----------------------------------------------------------------
  subroutine dumpR2(array)
    real, dimension(:,:), pointer          :: array
    integer :: esize
    integer :: n1,n2

    call auxscr(trim(dumpname))

    esize = 4
    call auxputch("esize",'i',esize,trim(dumpname))
    n1 = size(array,1)
    call auxputch("n1",'i',n1,trim(dumpname))
    n2 = size(array,2)
    call auxputch("n2",'i',n2,trim(dumpname))

    call sep_write(array,trim(dumpname))
  end subroutine dumpR2
  !----------------------------------------------------------------
  subroutine dumpR3(array)
    real, dimension(:,:,:), pointer        :: array
    integer :: esize
    integer :: n1,n2,n3

    call auxscr(trim(dumpname))

    esize = 4
    call auxputch("esize",'i',esize,trim(dumpname))
    n1 = size(array,1)
    call auxputch("n1",'i',n1,trim(dumpname))
    n2 = size(array,2)
    call auxputch("n2",'i',n2,trim(dumpname))
    n3 = size(array,3)
    call auxputch("n3",'i',n3,trim(dumpname))

    call sep_write(array,trim(dumpname))
  end subroutine dumpR3
  !----------------------------------------------------------------
  subroutine dumpR4(array)
    real, dimension(:,:,:,:), pointer      :: array
    integer :: esize
    integer :: n1,n2,n3,n4

    call auxscr(trim(dumpname))

    esize = 4
    call auxputch("esize",'i',esize,trim(dumpname))
    n1 = size(array,1)
    call auxputch("n1",'i',n1,trim(dumpname))
    n2 = size(array,2)
    call auxputch("n2",'i',n2,trim(dumpname))
    n3 = size(array,3)
    call auxputch("n3",'i',n3,trim(dumpname))
    n4 = size(array,4)
    call auxputch("n4",'i',n4,trim(dumpname))

    call sep_write(array,trim(dumpname))
  end subroutine dumpR4
  !----------------------------------------------------------------
  subroutine dumpR5(array)
    real, dimension(:,:,:,:,:), pointer    :: array
    integer :: esize
    integer :: n1,n2,n3,n4,n5

    call auxscr(trim(dumpname))

    esize = 4
    call auxputch("esize",'i',esize,trim(dumpname))
    n1 = size(array,1)
    call auxputch("n1",'i',n1,trim(dumpname))
    n2 = size(array,2)
    call auxputch("n2",'i',n2,trim(dumpname))
    n3 = size(array,3)
    call auxputch("n3",'i',n3,trim(dumpname))
    n4 = size(array,4)
    call auxputch("n4",'i',n4,trim(dumpname))
    n5 = size(array,5)
    call auxputch("n5",'i',n5,trim(dumpname))

    call sep_write(array,trim(dumpname))
  end subroutine dumpR5
  !----------------------------------------------------------------

  !----------------------------------------------------------------
  subroutine dumpC1(array)
    complex, dimension(:), pointer         :: array
    integer :: esize
    integer :: n1

    call auxscr(trim(dumpname))

    esize = 8
    call auxputch("esize",'i',esize,trim(dumpname))
    n1 = size(array,1)
    call auxputch("n1",'i',n1,trim(dumpname))

    call sep_write(array,trim(dumpname))
  end subroutine dumpC1
  !----------------------------------------------------------------
  subroutine dumpC2(array)
    complex, dimension(:,:), pointer       :: array
    integer :: esize
    integer :: n1,n2

    call auxscr(trim(dumpname))

    esize = 8
    call auxputch("esize",'i',esize,trim(dumpname))
    n1 = size(array,1)
    call auxputch("n1",'i',n1,trim(dumpname))
    n2 = size(array,2)
    call auxputch("n2",'i',n2,trim(dumpname))

    call sep_write(array,trim(dumpname))
  end subroutine dumpC2
  !----------------------------------------------------------------
  subroutine dumpC3(array)
    complex, dimension(:,:,:), pointer     :: array
    integer :: esize
    integer :: n1,n2,n3

    call auxscr(trim(dumpname))

    esize = 8
    call auxputch("esize",'i',esize,trim(dumpname))
    n1 = size(array,1)
    call auxputch("n1",'i',n1,trim(dumpname))
    n2 = size(array,2)
    call auxputch("n2",'i',n2,trim(dumpname))
    n3 = size(array,3)
    call auxputch("n3",'i',n3,trim(dumpname))

    call sep_write(array,trim(dumpname))
  end subroutine dumpC3
  !----------------------------------------------------------------
  subroutine dumpC4(array)
    complex, dimension(:,:,:,:), pointer   :: array
    integer :: esize
    integer :: n1,n2,n3,n4

    call auxscr(trim(dumpname))

    esize = 8
    call auxputch("esize",'i',esize,trim(dumpname))
    n1 = size(array,1)
    call auxputch("n1",'i',n1,trim(dumpname))
    n2 = size(array,2)
    call auxputch("n2",'i',n2,trim(dumpname))
    n3 = size(array,3)
    call auxputch("n3",'i',n3,trim(dumpname))
    n4 = size(array,4)
    call auxputch("n4",'i',n4,trim(dumpname))

    call sep_write(array,trim(dumpname))
  end subroutine dumpC4
  !----------------------------------------------------------------
  subroutine dumpC5(array)
    complex, dimension(:,:,:,:,:), pointer :: array
    integer :: esize
    integer :: n1,n2,n3,n4,n5

    call auxscr(trim(dumpname))

    esize = 8
    call auxputch("esize",'i',esize,trim(dumpname))
    n1 = size(array,1)
    call auxputch("n1",'i',n1,trim(dumpname))
    n2 = size(array,2)
    call auxputch("n2",'i',n2,trim(dumpname))
    n3 = size(array,3)
    call auxputch("n3",'i',n3,trim(dumpname))
    n4 = size(array,4)
    call auxputch("n4",'i',n4,trim(dumpname))
    n5 = size(array,5)
    call auxputch("n5",'i',n5,trim(dumpname))

    call sep_write(array,trim(dumpname))
  end subroutine dumpC5
  !----------------------------------------------------------------
end module wei_dump





