! Expects data to be (n1*n1*n4) the ns come from the green function
program mig
use sep

implicit none
integer                                   :: n1,n2,n3,n4,noff
real                                      :: o1,o2,o3,o4
real                                      :: d1,d2,d3,d4 
integer                                   :: esize,ix,ixr,ixs,i,iz,block_size,ioff
complex, dimension(:,:,:),   allocatable  :: data
real,    dimension(:,:,:,:), allocatable  :: modelw
complex, dimension(:,:,:,:), allocatable  :: green
complex, dimension(:,:)    , allocatable  :: aaaixz,aaajxz
integer, external                         :: sreed,srite


call sep_init()

call from_history('n1',n1); call from_history('d1',d1); call from_history('o1',o1)
call from_history('n2',n2); call from_history('d2',d2); call from_history('o2',o2)
call from_history('n3',n3); call from_history('d3',d3); call from_history('o3',o3)
call from_history('n4',n4); call from_history('d4',d4); call from_history('o4',o4)
call from_history("esize",esize)

call from_param('noff',noff,1)        

call to_history('n1',n2);   call to_history('d1',d2); call to_history('o1',o2); call to_history('label1',"z_")
call to_history('n2',n3);   call to_history('d2',d3); call to_history('o2',o3); call to_history('label2',"x_")
call to_history('n3',noff); call to_history('d3',d3); call to_history('o3',0);  call to_history('label3',"h_")
call to_history('n4',n4);   call to_history('d4',d4); call to_history('o4',o4); call to_history('label4',"w_")
call to_history("esize",esize/2)

write(0,*)"n1,n2,n3,n4",n1,n2,n3,n4
write(0,*)"d1,d2,d3,d4",d1,d2,d3,d4
write(0,*)"o1,o2,o3,o4",o1,o2,o3,o4

call sep_close()

call sep_begin_prog()

allocate(green(n1,n2,n3,n4),data(n1,n1,n4),modelw(n2,n3,noff,n4),aaaixz(n1,n4),aaajxz(n1,n4))

if (sreed("in",green,esize*n1*n2*n3*n4) /= esize*n1*n2*n3*n4) &
call seperr("Error reading Green function")

modelw=0.
if (sreed("data",data,esize*n1*n1*n4) /= esize*n1*n1*n4) &
call seperr("Error reading data")

do ix=1,n3
do iz=1,n2
  do ioff=1,noff
    if ( (ix+ioff-1 >= 1) .and. (ix+ioff-1 <= n3) .and. &
         (ix-ioff+1 >= 1) .and. (ix-ioff+1 <= n3) )  then
      aaaixz(1:n1,:)=conjg(green(1:n1,iz,ix+ioff-1,:))
      aaajxz(1:n1,:)=conjg(green(1:n1,iz,ix-ioff+1,:))
    else
      aaaixz(1:n1,:)=(0.,0.)
      aaajxz(1:n1,:)=(0.,0.)
    endif
    do ixs=1,n1
    do ixr=1,n1
      modelw(iz,ix,ioff,:)=modelw(iz,ix,ioff,:)+aaaixz(ixs,:)*aaajxz(ixr,:)*conjg(data(ixr,ixs,:))
    enddo
    enddo
  enddo
enddo
enddo

if (srite("out",modelw,esize*n2*n3*noff*n4/2) /= esize*n2*n3*noff*n4/2) &
call seperr("Error writing image")

deallocate(green,data,modelw,aaaixz,aaajxz)

call sep_end_prog()

end program mig 
