program migmod 
use sep

implicit none

integer                                    :: n1,n2,n3,n4,noff
real                                       :: o1,o2,o3,o4
real                                       :: d1,d2,d3,d4 
logical                                    :: adj
integer                                    :: esize,ix,ixr,ixs,i,iz,block_size,ir,ioff
complex, dimension(:,:,:)   , allocatable  :: data
real,    dimension(:,:,:)   , allocatable  :: model
complex, dimension(:,:,:,:) , allocatable  :: green
complex, dimension(:)       , allocatable  :: aaaixz,aaajxz
integer, external                          :: sreed,srite


call sep_init()

call from_history('n1',n1); call from_history('d1',d1); call from_history('o1',o1)
call from_history('n2',n2); call from_history('d2',d2); call from_history('o2',o2)
call from_history('n3',n3); call from_history('d3',d3); call from_history('o3',o3)
call from_history('n4',n4); call from_history('d4',d4); call from_history('o4',o4)
call from_history("esize",esize)

call from_param("ir",ir,10)
call from_param("noff",noff,1)

call to_history('n1',n1); call to_history('d1',d1); call to_history('o1',o1) ; call to_history('label1',"xr")
call to_history('n2',n1); call to_history('d2',d1); call to_history('o2',o1) ; call to_history('label2',"xs")
call to_history('n3',n4); call to_history('d3',d4); call to_history('o3',o4) ; call to_history('label3',"w_")
call to_history('n4', 1); call to_history('d4',0.); call to_history('o4',0.) ; call to_history('label4',"  ") 
call to_history("esize",esize)

write(0,*)"n1,n2,n3,n4",n1,n2,n3,n4
write(0,*)"d1,d2,d3,d4",d1,d2,d3,d4
write(0,*)"o1,o2,o3,o4",o1,o2,o3,o4

call sep_close()

call sep_begin_prog()
write(0,*)'hola 1'
allocate(green(n1,n2,n3,n4),data(n1,n1,n4),model(n2,noff,n3),aaaixz(n4),aaajxz(n4))
if (sreed("in",green,esize*n1*n2*n3*n4) /= esize*n1*n2*n3*n4) &
call seperr("Error reading Green function")



data=(0.,0.)
model=0.
model(ir,:,:)=1.
write(0,*)'hola 2'
do ixs=1,n1
do ixr=1,n1
  do ioff=1,noff
    do ix=1,n3
    do iz=1,n2
      if ( (ix+ioff-1 >= 1) .and. (ix+ioff-1 <= n3) .and. &
           (ix-ioff-1 >= 1) .and. (ix-ioff-1 <= n3) )  then
        aaaixz(:)=conjg(green(ixs,iz,ix+ioff-1,:))
        aaajxz(:)=conjg(green(ixr,iz,ix-ioff+1,:))
      else
        aaaixz(:)=(0.,0.)
        aaajxz(:)=(0.,0.)
      endif
      data(ixr,ixs,:)=data(ixr,ixs,:)+aaaixz(:)*aaajxz(:)*model(iz,ioff,ix)
    enddo
    enddo
  enddo
enddo
enddo
write(0,*)'hola 3'
if (srite("out",data,esize*n1*n1*n4) /= esize*n1*n1*n4) &
call seperr("Error writing data") 

deallocate(green,data,model,aaaixz,aaajxz)

call sep_end_prog()

end program migmod 
