      module omp_sector_real_bob  !  omp part of L_tL programs
      
      contains

      subroutine omp_do(nx_in,ny_in,nz_in,nax_in,nay_in,naz_in,nax2_in,nay2_in,naz2_in, &
                        ix_in,iy_in,green_in,LtL_out,ratiox_in,ratioy_in,nsux_in,nsuy_in,nry_in,nrx_in,nsy_in,nsx_in)
      implicit none
      integer                      , intent (in)  :: nx_in,ny_in,nz_in,nax_in,nay_in,naz_in,nax2_in,nay2_in,naz2_in,ix_in,iy_in
      integer                      , intent (in)  :: ratiox_in,ratioy_in,nsux_in,nsuy_in,nry_in,nrx_in,nsy_in,nsx_in
      complex, dimension(:,:,:,:,:), intent (in)  :: green_in
      real   , dimension(:,:,:,:,:), intent (out) :: LtL_out
      complex, dimension(:,:)      , allocatable  :: aaai,aaaj,mult
      integer                                     :: iz,iax,iay,iaz,isx,isy,irx,iry,iix,iiy,iiz,iisy,iisx,iiisy,iiisx
      complex                                     :: pp,mys
      real                                        :: ppp

      allocate(aaai(nsuy_in,nsux_in),aaaj(nsuy_in,nsux_in),mult(nry_in,nrx_in))
     z:  do iz=1,nz_in
        aaai(1:nsuy_in,1:nsux_in)=conjg(green_in(1:nsuy_in,1:nsux_in,iz+1,ix_in+1,iy_in+1))
     ax:   do iax=1,nax_in
          iix=max(1,min(nx_in+2,ix_in-nax2_in+iax))
     ay:   do iay=1,nay_in
          iiy=max(1,min(ny_in+2,iy_in-nay2_in+iay))
     az:   do iaz=1,naz_in
          iiz=max(1,min(nz_in+2,iz   -naz2_in+iaz))
          aaaj(1:nsuy_in,1:nsux_in)=green_in(1:nsuy_in,1:nsux_in,iiz,iix,iiy)
          ppp=(0.,0.)
          mult=aaai(1:nry_in,1:nrx_in)*aaaj(1:nry_in,1:nrx_in) 
          mys=sum(mult)  
      sx: do isx=1,nsx_in                   
            iisx=(isx-1)*ratiox_in+1
            iiisx=isx*ratiox_in
            if (iisx > nsux_in .or. iiisx > nsux_in) exit 
      sy: do isy=1,nsy_in                   
            iisy=(isy-1)*ratioy_in+1
            iiisy=isy*ratioy_in
            if (iisy > nsux_in .or. iiisy > nsux_in) cycle sx
            pp=aaai(iisy,iisx)*aaaj(iisy,iisx)
            ppp=ppp+real(mys*pp)             
            mys=mys-sum(aaai(iisy       :iiisy       ,iisx       :iiisx       )  &
                       *aaaj(iisy       :iiisy       ,iisx       :iiisx       )) &
                   +sum(aaai(iisy+nry_in:iiisy+nry_in,iisx+nrx_in:iiisx+nrx_in)  &
                       *aaaj(iisy+nry_in:iiisy+nry_in,iisx+nrx_in:iiisx+nrx_in))
          enddo sy
          enddo sx
          LtL_out(iaz,iax,iay,iz,ix_in)=ppp
        enddo az
        enddo ay
        enddo ax
      enddo z
      deallocate(aaai,aaaj,mult)
      end subroutine

      end module
