      module omp_sector_real_ng  !  omp part of L_tL programs
      
      contains

      subroutine omp_do(nx_in,ny_in,nz_in,nax_in,nay_in,naz_in,nax2_in,nay2_in,naz2_in, &
                        ix_in,iy_in,green_in,LtL_out,nsrx_in,nsry_in,nsx_in,nsy_in)
      implicit none
      integer                      , intent (in)  :: nx_in,ny_in,nz_in,nax_in,nay_in,naz_in,nax2_in,nay2_in,naz2_in,ix_in,iy_in
      integer                      , intent (in)  :: nsrx_in,nsry_in,nsx_in,nsy_in
      complex, dimension(:,:,:,:,:), intent (in)  :: green_in
      real   , dimension(:,:,:,:,:), intent (out) :: LtL_out
      complex, dimension(:,:)      , allocatable  :: aaai,aaaj
      integer                                     :: iz,iax,iay,iaz,isx,isy,irx,iry,iix,iiy,iiz
      complex                                     :: pp
      real                                        :: ppp

      allocate(aaai(nsy_in,nsx_in),aaaj(nsy_in,nsx_in))
      do iz=1,nz_in
        aaai(1:nsy_in,1:nsx_in)=conjg(green_in(1:nsy_in,1:nsx_in,iz,ix_in,iy_in))
        do iax=1,nax_in
          iix=ix_in-nax2_in+iax-1
        do iay=1,nay_in
          iiy=iy_in-nay2_in+iay-1
        do iaz=1,naz_in
          iiz=iz   -naz2_in+iaz-1
          if (  (iiz >= 1    ) .and. (iix >=1  )    .and. (iiy >=1  )   .and. &
                (iiz <= nz_in) .and. (iix <= nx_in) .and. (iiy <= ny_in) ) then
            aaaj(1:nsy_in,1:nsx_in)=green_in(1:nsy_in,1:nsx_in,iiz,iix,iiy)
          else
            aaaj(1:nsy_in,1:nsx_in)=(0.,0.)
          endif
          ppp=(0.,0.)
          do isx=1,nsx_in,nsrx_in                   
          do isy=1,nsy_in,nsry_in                   
            pp=aaai(isy,isx)*aaaj(isy,isx)
            do irx=1,nsx_in 
            do iry=1,nsy_in 
              ppp=ppp+real(pp*aaai(iry,irx)*aaaj(iry,irx))
            enddo
            enddo
          enddo
          enddo
          LtL_out(iaz,iax,iay,iz,ix_in)=ppp
        enddo
        enddo
        enddo
      enddo
      deallocate(aaai,aaaj)
      end subroutine

      end module
