module sparse_matmult  
! sparse matrix multiply and its adjoint Ax=y and A'y=x
use adj_mod

implicit none
real ,private,  dimension (:,:), pointer  :: bb 

contains

  subroutine smatmult_init ( bb_in )
    real ,   dimension (:,:), pointer :: bb_in 
    bb => bb_in
  end subroutine

  function smatmult_lop ( adj, add, x, y) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: x,y 
    call adjnull (adj,add,x,y )
    call smatmult_lop2(adj,add,x,y )
    stat=0
  end function 

  subroutine smatmult_lop2(adj,add,x,y)
    logical,intent(in)   :: adj,add 
    real, dimension (:)  :: x 
    real, dimension (:)  :: y 
    integer              :: irow,icol,inonzero 
    do inonzero=1,size(bb(:,1))
      irow=bb(inonzero,1)
      icol=bb(inonzero,2)
      if ( adj) then
        x(icol)=x(icol)+bb(inonzero,3)*y(irow)
      else
        y(irow)=y(irow)+bb(inonzero,3)*x(icol)
      endif
    end do
  end subroutine 

  subroutine smatmult_close()
  end subroutine 

end module      
