module sparse_mapping1  
! Mapp a sep cube to sparse matrix 

contains
subroutine sp_cont ( n1_in,n2_in,n3_in,n4_in,cont )
  implicit none
  integer                             :: n1_in,n2_in,n3_in,n4_in ! nz nx (nhz nhx allways odd)
  integer                             :: i1,i2,i3,i4,i33,i44,cont,irow,icol
  
   cont=0 

   do i1=1,n1_in
     do i2=1,n2_in
       irow=n1_in*(i2-1)+i1
       do i3=1,n3_in
         do i4=1,n4_in
           i33=i1-(n3_in-1)/2+i3-1
           i44=i2-(n4_in-1)/2+i4-1
           icol=n1_in*(i44-1)+i33
           if ( irow >=1 .and. irow <= n1_in*n2_in .and. icol >=1 .and. icol <= n1_in*n2_in) then
             cont=cont+1
           end if
         enddo
       enddo
     enddo
   enddo
  
end subroutine

subroutine sp_mapp ( Hcube_in, Hsp_out,n1_in,n2_in,n3_in,n4_in )
  implicit none
  real , dimension (:,:,:,:), pointer :: Hcube_in 
  real , dimension (:,:),     pointer :: Hsp_out 
  real , dimension (:,:),     pointer :: test_out 
  integer                             :: n1_in,n2_in,n3_in,n4_in ! nz nx (nhz nhx allways odd)
  integer                             :: i1,i2,i3,i4,i33,i44,cont,irow,icol
  
   cont=0 

   do i1=1,n1_in
     do i2=1,n2_in
       irow=n1_in*(i2-1)+i1
       do i3=1,n3_in
         do i4=1,n4_in
           i33=i1-(n3_in-1)/2+i3-1
           i44=i2-(n4_in-1)/2+i4-1
           icol=n1_in*(i44-1)+i33 
           if ( irow >=1 .and. irow <= n1_in*n2_in .and. icol >=1 .and. icol <= n1_in*n2_in) then
             cont=cont+1
             Hsp_out(cont,1)=irow
             Hsp_out(cont,2)=icol
             Hsp_out(cont,3)=Hcube_in(i1,i2,i3,i4)
           end if
         enddo
       enddo
     enddo
   enddo
  
end subroutine

end module      
