module wei_type
  !! WEI type definitions
  use wei_util
 
  implicit none
!----------------------------------------------------------------
  type slow_comp
     character(len=128) :: tag_0  !non-local tag (actual input/output)
     character(len=128) :: tag
     character(len=128) :: tag_local,tag_var
     character(len=128) :: from
     integer            :: bites,esize
     logical            :: velocity
     type(axis)         :: amx,amy,az !!ai & am may be confused in places

     !! block binary array
     complex, dimension(:,:,:),     pointer :: bin !slowness (mx,my,z)
  end type slow_comp
!----------------------------------------------------------------
  type slow 
   type(slow_comp) :: s_g,s_s
   type(slow_comp) :: s1,s2
   logical            :: conv_wave 
   integer :: indx,indy,finy,finx
   complex, dimension(:,:,:), pointer :: pba !slowness (mx,my,nzs)
  end type slow 
!----------------------------------------------------------------
  type dat
     character(len=128) :: tag_0
     character(len=128) :: tag
     character(len=128) :: from
     integer            :: bites
     integer            :: indx,indy !!start index to insert into work space
     integer            :: finx,finy !!indx + amx%n -1
     integer            :: esize
     type(axis)         :: amx, amy, asx, asy, aw, aw_local !!input axes
     !! block binary array
     complex, dimension(:,:,:), pointer :: bin
  end type dat
!----------------------------------------------------------------
  type imag
     character(len=128) :: tag_0
     character(len=128) :: tag,tag_var
     character(len=128) :: from
     integer            :: bites
     integer            :: esize
     integer            :: indx,indy,finx,finy
     type(axis)         :: amx,amy,ahx,ahy,az,aix,aiy,aw

     !! block binary array
     complex, dimension(:,:,:,:,:), pointer :: bin_tot
     complex, dimension(:,:,:,:,:), pointer :: bin
     
  end type imag
!----------------------------------------------------------------
  type wfld
     character(len=128) :: tag_0	
     character(len=128) :: tag
     character(len=128) :: from
     integer            :: bites
     type(axis)         :: amx,amy,asx,asy,aw,az,aw_local
  end type wfld
!----------------------------------------------------------------
  type tkmap
     real,    dimension(:),         pointer :: kx,ky
  end type tkmap
!----------------------------------------------------------------
  type txmap
     real,    dimension(:),         pointer :: mx,my
  end type txmap
!----------------------------------------------------------------
  type slowmapthread
     integer, dimension(:,:,:),   pointer :: si      !! f(mx,my,z)
     integer, dimension(:)    ,   pointer :: nrs     !! f(z)
     real,    dimension(:,:)  ,   pointer :: sz,bound
     logical :: source
  end type slowmapthread
!----------------------------------------------------------------
  type slowmap
     !! FKop slowness
     real,    dimension(:, :) ,pointer :: sz_s,sz_r,sz,bound,bound_r,bound_s !! f(z,nfk)
     !! Number of reference slownesses
     integer, dimension(:)    ,pointer :: nrs,nrs_s,nrs_r  !! f(z)
     !! FXop slowness interpolation map
     integer, dimension(:,:,:),pointer :: si        !! f(mx,my,z)
     integer, dimension(:,:,:),pointer :: si_r      !! f(mx,my,z)
     integer, dimension(:,:,:),pointer :: si_s      !! f(mx,my,z)
     logical :: source
  end type slowmap
!----------------------------------------------------------------
end module wei_type
